
/*

Copyright (c) 2000-2020 ARS Technologies, All Rights Reserved

  USB2 - ISA  test application

	For details on using - please refer to .txt files

*/

#ifdef		WIN32

#include "stdafx.h"

#else

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <sys/types.h>

#endif


// !!! main switches for building !!!
//#define		WINDOWS					// link with - libarsusb4.lib
//#define		LNX_MAC						// link with - libarsusb4.a


#include <stdio.h>



// !!!!!!!!
#ifdef		WIN32
//#include <windows.h>

#include <conio.h>


//	HINSTANCE hinstance;
	
#endif


// !!!!!!!!
#ifdef		LNX_MAC
#include <dlfcn.h>
#include <fcntl.h>		/* open */
#include <unistd.h>		/* exit */
#include <sys/ioctl.h>	/* ioctl */

#include <pthread.h>

#include <sys/stat.h>
#include <sys/types.h>

#include <sys/mman.h>
#include <sys/syscall.h>
#include <sys/utsname.h>

#define BYTE	unsigned char
#define WORD	unsigned short
#define DWORD	unsigned long

#define BOOL	int
#define FALSE	0
#define TRUE	1

// redefining - calling convention
/*
#define	outb(a, b)	out8(a, b)
#define	outw(a, b)	out16(a, b)
#define inb		in8
#define inw		in16
*/
	void* hinstance;
#endif




#include "libars4.h"








//#ifdef		WINDOWS
//int _tmain(int argc, _TCHAR* argv[])
//#else
//#endif
int main(int argc, char* argv[])
{
	char sel[4];
	int val,irq,mem, mem1;
	WORD port = 0;
	int i,  dev;
	BYTE bdt;
	BYTE buf[0x100];


	printf("\n ARS Technologies - USB2  - test application\n");	


	// !!!!!!!!!!!!! important !!!!!!!!!!!!!!!!!!!!!
	printf("\n It is recommended to run this program in a specific way -");	
	printf("\n Windows - adjust security settings and do 'run as administrator'");	
	printf("\n Linux - run as super-user for ex. -> sudo isarw\n");	

#ifndef		WINDOWS
        if ( getuid() )
	{
        	printf("Need to start the program in a way as a 'root'");
		return 0;
	}
#endif


	if ( !ArsInit() )
	{
		printf("\n err - unable to initialize ");
		return 0;
	}

//	printf("???");	return;	// ?????

l1:
	printf("\n\n type test number and press Enter - ");
	printf("\n1-digital output, 2-detect IRQ, 3-memory block read,   0-exit - \n");
	scanf("%c", &sel);

	if (sel[0] == '1')
		goto dig_out;
	else if (sel[0] == '2')
		goto det_irq;
	else if (sel[0] == '3')
		goto mem_rd;
	else if (sel[0] == '0')
		goto ex;

	goto l1;


// !!! digital output test !!!
dig_out:
	printf("\n\n please connect usb2isa + isa i/o card (1 ide, 1 fl., 2 ser, 1 par), and check in the Enumerator");
	// set i/o port - for a par.port, normally 0x1f0 / 0x170
	printf("\n type par.port i/o port address for ex. USB2ISA(0x378/278/778/678), SSI2 ISA(0x8278/8378) - ");
	scanf("%x", &port);
	if (!port)	// || !len)
	{
		printf("\n ??? error selecting an i/o port ");
		goto l1;
	}

	// chk if present
	out8( port+0, 0x5a);
	bdt = in8( port+0);
	if ( bdt == 0x5a)
		goto do1;
	// err
	printf("\n ??? error - put isa card on, or connect to usb ...");	
	goto l1;

do1:
	printf("\n type digital output value - ");
	scanf("%x", &val);

	out8( port+0, (BYTE)val);

	printf("\n please check pin2-9 on the 25pin par.port connector for the digital out value");	


// !!! exrcise of i/o port api set - list all available commands
// shown arbitrary values written/read , to arbitrary port - no real data; 
// the hardware has to allow 8 or 16 or 32bit / read or write , to have real data
 
	out8( port+4, 0x12);
	i = in8( port+4);
	out16( port+4, 0x1234);
	i = in16( port+4);
// !!! Note - 32bit operations are not used on USB2 ISA/PCMCIA products
//	out32( port+4, 0x12345678);		
//	i = in32( port+4);

	

	goto l1;


   
 
// !!! generate irq test !!!
det_irq:
	printf("\n\n please connect usb2isa + isa i/o card (1 ide, 1 fl., 2 ser, 1 par), and check in the Enumerator");
	printf("\n !!! connect with a wire pin9 and pin10 of the 25pin par.port connector !!!");
	printf("\n !!! make sure the par.port IRQ is connected through the jumpers on the ISA card !!!");
	// set i/o port - for a par.port, normally 0x1f0 / 0x170
	printf("\n type par.port i/o port address for ex. ");
	printf("\n USB2ISA(0x378/278/778/678), SSI2 ISA(0x8278/8378) - ");
	scanf("%x", &port);
	if (!port)	// || !len)
	{
		printf("\n ??? error selecting an i/o port ");
		goto l1;
	}

	// chk if present
	out8( port+0, 0x5a);
	bdt = in8( port+0);
	if ( bdt == 0x5a)
		goto di1;
	// err
	printf("\n ??? error - put isa card on, or connect to usb ...");	
	goto l1;

di1:
	// !!! port/dev number - taken from enumerator
//	dev = 3;
//	printf("\n type device number ('ssi2 isa-0'=0 , 'usb2isa-p2'=2) - ");
//	scanf("%x", &dev);


	// ssi2 dev = 0x10
	if (!dev)
		dev = 0x10;		

	// irq = 0
	out8( port+0, 0x0);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = GetIrqDma();
	printf("\n event1, irq = %x - ", irq);

	// enable irq line
	out8( port+2, 0x10);

	// irq = 1
	out8( port+0, 0x80);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = GetIrqDma();
	printf("\n event2, irq = %x - ", irq);



	// irq = 0
	out8( port+0, 0x0);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = GetIrqDma();
	printf("\n event3, irq = %x - ", irq);


	// disable irq line
	out8( port+2, 0x0);

	goto l1;




// !!! vga bios read !!!
mem_rd:
	printf("\n\n please connect usb2isa + isa vga card , and check in the Enumerator");
	// set phys mem addr - video BIOS starts from 0x0c0000
	printf("\n type VGA BIOS memory address to read, for ex. ");
	printf("\n USB2ISA(0x000c0000), SSI2 ISA(0xff0c0000) - ");
	scanf("%x", &mem);
	mem1 = mem & 0x00ffffff;
	if (!mem1 || (mem1 < 0x0b0000) || (mem1 > 0x0f0000) )
	{
		printf("\n ??? error selecting memory area ");
		goto l1;
	}

	// single rd cmd
	printf("\n single read : ISA VGA memory or BIOS content from address - %x ", mem);
	for (i=0; i<0x100; i++)
	{
		if ( !(i & 0x0f) )
			printf("\n");
		buf[i] = rd8(mem+i);
	}



	// display
	for (i=0; i<0x100; i++)
	{
		if ( !(i & 0x0f) )
			printf("\n");
		printf("%02x / %c, ",buf[i],buf[i]);
	}


// !!! exrcise of physical memory api set - list all available commands
// shown arbitrary values written/read , to arbitrary memory location - no real data; 
// the hardware has to allow 8 or 16 or 32bit / read or write , to have real data


	wr8(mem+4, 0x12);
	i = rd8(mem+4);
	wr16(mem+4, 0x1234);
	i = rd16(mem+4);
// !!! Note - 32bit operations are not used on USB2 ISA/PCMCIA products
//	wr32(mem+4, 0x12345678);
//	i = rd32(mem+4);



	goto l1;







ex: ;
	return 1;
}




