
/*

Copyright (c) 2000-2020 ARS Technologies, All Rights Reserved

  USB2 - ISA  test application

	For details on using - please refer to .txt files

*/


#include "stdafx.h"

#ifndef		WIN32
//#else

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <sys/types.h>

#endif


// !!! main switches for building !!!
//#define		WINDOWS					
//#define		LNX_MAC						





#include <stdio.h>



// !!!!!!!!
#ifdef		WIN32
//#include <windows.h>

#include <conio.h>


//	HINSTANCE hinstance;
	
#endif


// !!!!!!!!
#ifdef		LNX_MAC
#include <dlfcn.h>
#include <fcntl.h>		/* open */
#include <unistd.h>		/* exit */
#include <sys/ioctl.h>	/* ioctl */

#include <pthread.h>

#include <sys/stat.h>
#include <sys/types.h>

#include <sys/mman.h>
#include <sys/syscall.h>
#include <sys/utsname.h>

#define BYTE	unsigned char
#define WORD	unsigned short
#define DWORD	unsigned long

#define BOOL	int
#define FALSE	0
#define TRUE	1

// redefining - calling convention
/*
#define	outb(a, b)	out8(a, b)
#define	outw(a, b)	out16(a, b)
#define inb		in8
#define inw		in16
*/
	void* hinstance;
#endif






// ------------------------------------------------------
// windows platform - choose the way of getting API - _cdecl or _stdcall
// declarations in - "libars4.h"

#include "libars4.h"


int cdcl=FALSE;		// this var. is set in - LoadARSUSBdll2()


//   __cdecl		APIs
in16T in16;
in8T in8;
out16T out16;
out8T out8;
rd16T rd16;
rd8T rd8;
wr16T wr16;
wr8T wr8;

GetIrqDmaT GetIrqDma;
 ArsExitT	ArsExit;
 ArsInitT	ArsInit;


//   __stdcall		APIs
vin16T vin16;
vin8T vin8;
vout16T vout16;
vout8T vout8;
vrd16T vrd16;
vrd8T vrd8;
vwr16T vwr16;
vwr8T vwr8;

vGetIrqDmaT vGetIrqDma;
 vArsExitT	vArsExit;
 vArsInitT	vArsInit;






#ifdef		LINUX
	void* hinstance;
#else
	HINSTANCE hinstance;
#endif


int LoadARSUSBdll2()
{

#ifdef		LINUX
	char dl[] = "/usr/lib/libars4.so";

//#ifdef _LINUX
	// win ce part
 	hinstance = dlopen (dl, RTLD_LAZY);
//#endif


	if(hinstance == NULL) 
	{
//		printf("\nLoadARSUSBdll - hinstance = NULL\n");
		return 0;
	}
	// linux part
//	void (*test)() = dlsym (handle, my_function);
	in16 = (in16T)dlsym(hinstance,"in16" ); 
	in8 = (in8T)dlsym(hinstance,"in8" ); 
	out16 = (out16T)dlsym(hinstance,"out16" ); 
	out8 = (out8T)dlsym(hinstance,"out8" ); 
	rd16 = (rd16T)dlsym(hinstance,"rd16" ); 
	rd8 = (rd8T)dlsym(hinstance,"rd8" ); 
	wr16 = (wr16T)dlsym(hinstance,"wr16" ); 
	wr8 = (wr8T)dlsym(hinstance,"wr8" ); 

	GetIrqDma = (GetIrqDmaT)dlsym(hinstance,"GetIrqDma" );
    ArsInit = (InitT)dlsym(hinstance,"ArsInit" );
    ArsExit = (ExitT)dlsym(hinstance,"ArsExit" );
#else
	// std win part
	char sDllPath[MAX_PATH+20];

	UINT LastChar = GetWindowsDirectory(sDllPath,MAX_PATH);
	strcat(sDllPath,"\\inf\\ARSUSB4.dll");						// windows\inf
	hinstance = ::LoadLibrary(sDllPath);
	if(hinstance == NULL) 
	{
	 LastChar = GetSystemDirectory(sDllPath,MAX_PATH);
	strcat(sDllPath,"\\ARSUSB4.dll");						// windows\system32
	hinstance = ::LoadLibrary(sDllPath);
	if(hinstance == NULL) 
	{
		printf("\nLoadARSUSBdll - hinstance = NULL\n");
		return 0;
	}
	}

	// windows part
//#ifdef	CDECL
	in16 = (in16T)::GetProcAddress(hinstance,"in16" ); 
	in8 = (in8T)::GetProcAddress(hinstance,"in8" ); 
	out16 = (out16T)::GetProcAddress(hinstance,"out16" ); 
	out8 = (out8T)::GetProcAddress(hinstance,"out8" ); 
	rd16 = (rd16T)::GetProcAddress(hinstance,"rd16" ); 
	rd8 = (rd8T)::GetProcAddress(hinstance,"rd8" ); 
	wr16 = (wr16T)::GetProcAddress(hinstance,"wr16" ); 
	wr8 = (wr8T)::GetProcAddress(hinstance,"wr8" ); 

	GetIrqDma = (GetIrqDmaT)::GetProcAddress(hinstance,"GetIrqDma" );
    ArsInit = (ArsInitT)GetProcAddress(hinstance,"ArsInit" );
    ArsExit = (ArsExitT)GetProcAddress(hinstance,"ArsExit" );
//#endif

	if (in16)
	{
		cdcl = TRUE;
		printf("\n !!!!!!!!!! choosing '__cdecl' api calling !!!!!!!!!!  \n");
	}


//#ifdef	STDCALL
	vin16 = (vin16T)::GetProcAddress(hinstance,"_vin16@4" ); 
	vin8 = (vin8T)::GetProcAddress(hinstance,"_vin8@4" ); 
	vout16 = (vout16T)::GetProcAddress(hinstance,"_vout16@8" ); 
	vout8 = (vout8T)::GetProcAddress(hinstance,"_vout8@8" ); 
	vrd16 = (vrd16T)::GetProcAddress(hinstance,"_vrd16@4" ); 
	vrd8 = (vrd8T)::GetProcAddress(hinstance,"_vrd8@4" ); 
	vwr16 = (vwr16T)::GetProcAddress(hinstance,"_vwr16@8" ); 
	vwr8 = (vwr8T)::GetProcAddress(hinstance,"_vwr8@8" ); 

	vGetIrqDma = (vGetIrqDmaT)::GetProcAddress(hinstance,"_vGetIrqDma@0" );
    vArsInit = (vArsInitT)GetProcAddress(hinstance,"_vArsInit@0" );
    vArsExit = (vArsExitT)GetProcAddress(hinstance,"_vArsExit@0" );
//#endif

#endif

	if (!in16 && vin16)
	{
		cdcl = FALSE;
		printf("\n !!!!!!!!!! choosing '__stdcall' api calling !!!!!!!!!!  \n");
	}


		printf("\n default API calling: in MS VC++ -> 'Project' menu -> 'Settings' submenu -> 'C/C++' tab -> ");
		printf("\n 'Category' dropdown = 'Code generation' -> 'Calling convention' dropdown = '__cdecl/__stdcall'\n");


	if( cdcl )			// __cdecl
	{
		if ( in16 == NULL || in8 == NULL || out16 == NULL || out8 == NULL || 
		rd16 == NULL || rd8 == NULL || wr16 == NULL || wr8 == NULL || ArsInit == NULL  || ArsExit == NULL || GetIrqDma == NULL	)
		{
			printf("\nLoadARSUSBdll - some __cdecl ptr = NULL\n");
			return 0;
		}
	}
	else				// __stdcall
	{
		if ( vin16 == NULL || vin8 == NULL || vout16 == NULL || vout8 == NULL || 
		vrd16 == NULL || vrd8 == NULL || vwr16 == NULL || vwr8 == NULL || vArsInit == NULL  || vArsExit == NULL || vGetIrqDma == NULL	)
		{
			printf("\nLoadARSUSBdll - some __stdcall ptr = NULL\n");
			return 0;
		}
	}


	return 1;
}


void UnloadARSUSBdll2()
{
#ifdef		LINUX
	dlclose (hinstance);
#else
    FreeLibrary(hinstance);
#endif
}







//#ifdef		WINDOWS
//int _tmain(int argc, _TCHAR* argv[])
//#else
//#endif
int main(int argc, char* argv[])
{
	char sel[4];
	int val,irq,mem, mem1;
	WORD port = 0;
	int i,  dev;
	BYTE bdt;
	BYTE buf[0x100];


	printf("\n ARS Technologies - USB2  - test application\n");	


	// !!!!!!!!!!!!! important !!!!!!!!!!!!!!!!!!!!!
	printf("\n It is recommended to run this program in a specific way -");	
	printf("\n Windows - adjust security settings and do 'run as administrator'");	
	printf("\n Linux - run as super-user for ex. -> sudo isarw\n");	

#ifndef		WIN32
        if ( getuid() )
	{
        	printf("Need to start the program in a way as a 'root'");
		return 0;
	}
#endif


	if ( !LoadARSUSBdll2() )
		return 0;




	if ( cdcl)
	{
		if ( !ArsInit() )		// __cdecl
			goto x0;
	}
	else
	{
		if ( !vArsInit() )		// __stdcall
		{
x0:
		printf("\n err - unable to initialize ");
		return 0;
		}
	}


l1:
	printf("\n\n type test number and press Enter - ");
	printf("\n1-digital output, 2-detect IRQ, 3-memory block read,   0-exit - ");
	scanf("%c", &sel);

	if (sel[0] == '1')
		goto dig_out;
	else if (sel[0] == '2')
		goto det_irq;
	else if (sel[0] == '3')
		goto mem_rd;
	else if (sel[0] == '0')
		goto ex;

	goto l1;


// !!! digital output test !!!
dig_out:
	printf("\n\n please connect usb2isa + isa i/o card (1 ide, 1 fl., 2 ser, 1 par), and check in the Enumerator");
	// set i/o port - for a par.port, normally 0x1f0 / 0x170
	printf("\n type par.port i/o port address for ex. USB2ISA(0x378/278/778/678), SSI2 ISA(0x8278/8378) - ");
	scanf("%x", &port);
	if (!port)	// || !len)
	{
		printf("\n ??? error selecting an i/o port ");
		goto l1;
	}



	if ( cdcl)
	{
// !!!!!!!!!!!!!!!!!!!!!! __cdecl !!!!!!!!!!!!!!!!!
	// chk if present
	out8( port+0, 0x5a);
	bdt = in8( port+0);
	if ( bdt == 0x5a)
		goto do1;
	// err
	printf("\n ??? error - put isa card on, or connect to usb ...");	
	goto l1;

do1:
	printf("\n type digital output value - ");
	scanf("%x", &val);

	out8( port+0, (BYTE)val);

	printf("\n please check pin2-9 on the 25pin par.port connector for the digital out value");	


// !!! exrcise of i/o port api set - list all available commands
// shown arbitrary values written/read , to arbitrary port - no real data; 
// the hardware has to allow 8 or 16 or 32bit / read or write , to have real data
 
	out8( port+4, 0x12);
	i = in8( port+4);
	out16( port+4, 0x1234);
	i = in16( port+4);
// !!! Note - 32bit operations are not used on USB2 ISA/PCMCIA products
//	out32( port+4, 0x12345678);		
//	i = in32( port+4);

	}
	else
	{
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!! __stdcall !!!!!!!!!!!!!!!!!!!!!!!!
	// chk if present
	vout8( port+0, 0x5a);
	bdt = vin8( port+0);
	if ( bdt == 0x5a)
		goto do1a;
	// err
	printf("\n ??? error - put isa card on, or connect to usb ...");	
	goto l1;

do1a:
	printf("\n type digital output value - ");
	scanf("%x", &val);

	vout8( port+0, (BYTE)val);

	printf("\n please check pin2-9 on the 25pin par.port connector for the digital out value");	


// !!! exrcise of i/o port api set - list all available commands
// shown arbitrary values written/read , to arbitrary port - no real data; 
// the hardware has to allow 8 or 16 or 32bit / read or write , to have real data
 
	vout8( port+4, 0x12);
	i = vin8( port+4);
	vout16( port+4, 0x1234);
	i = vin16( port+4);
// !!! Note - 32bit operations are not used on USB2 ISA/PCMCIA products
//	out32( port+4, 0x12345678);		
//	i = in32( port+4);
	}	

	goto l1;


   
 
// !!! generate irq test !!!
det_irq:
	printf("\n\n please connect usb2isa + isa i/o card (1 ide, 1 fl., 2 ser, 1 par), and check in the Enumerator");
	printf("\n !!! connect with a wire pin9 and pin10 of the 25pin par.port connector !!!");
	printf("\n !!! make sure the par.port IRQ is connected through the jumpers on the ISA card !!!");
	// set i/o port - for a par.port, normally 0x1f0 / 0x170
	printf("\n type par.port i/o port address for ex. ");
	printf("\n USB2ISA(0x378/278/778/678), SSI2 ISA(0x8278/8378) - ");
	scanf("%x", &port);
	if (!port)	// || !len)
	{
		printf("\n ??? error selecting an i/o port ");
		goto l1;
	}


	if ( cdcl)
	{
// !!!!!!!!!!!!!!!!!!!!!! __cdecl !!!!!!!!!!!!!!!!!
	// chk if present
	out8( port+0, 0x5a);
	bdt = in8( port+0);
	if ( bdt == 0x5a)
		goto di1;
	// err
	printf("\n ??? error - put isa card on, or connect to usb ...");	
	goto l1;

di1:
	// !!! port/dev number - taken from enumerator
//	dev = 3;
//	printf("\n type device number ('ssi2 isa-0'=0 , 'usb2isa-p2'=2) - ");
//	scanf("%x", &dev);


	// ssi2 dev = 0x10
	if (!dev)
		dev = 0x10;		

	// irq = 0
	out8( port+0, 0x0);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = GetIrqDma();
	printf("\n event1, irq = %x - ", irq);

	// enable irq line
	out8( port+2, 0x10);

	// irq = 1
	out8( port+0, 0x80);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = GetIrqDma();
	printf("\n event2, irq = %x - ", irq);



	// irq = 0
	out8( port+0, 0x0);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = GetIrqDma();
	printf("\n event3, irq = %x - ", irq);


	// disable irq line
	out8( port+2, 0x0);

	}
	else
	{
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!! __stdcall !!!!!!!!!!!!!!!!!!!!!!!!
	// chk if present
	vout8( port+0, 0x5a);
	bdt = vin8( port+0);
	if ( bdt == 0x5a)
		goto di1a;
	// err
	printf("\n ??? error - put isa card on, or connect to usb ...");	
	goto l1;

di1a:
	// !!! port/dev number - taken from enumerator
//	dev = 3;
//	printf("\n type device number ('ssi2 isa-0'=0 , 'usb2isa-p2'=2) - ");
//	scanf("%x", &dev);


	// ssi2 dev = 0x10
	if (!dev)
		dev = 0x10;		

	// irq = 0
	vout8( port+0, 0x0);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = vGetIrqDma();
	printf("\n event1, irq = %x - ", irq);

	// enable irq line
	vout8( port+2, 0x10);

	// irq = 1
	vout8( port+0, 0x80);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = vGetIrqDma();
	printf("\n event2, irq = %x - ", irq);



	// irq = 0
	vout8( port+0, 0x0);
	// delay
	printf("\n ... push a key and Enter to continue");	
	scanf("%c", &sel);
	// check irq
	irq = vGetIrqDma();
	printf("\n event3, irq = %x - ", irq);


	// disable irq line
	vout8( port+2, 0x0);


	}



	goto l1;




// !!! vga bios read !!!
mem_rd:
	printf("\n\n please connect usb2isa + isa vga card , and check in the Enumerator");
	// set phys mem addr - video BIOS starts from 0x0c0000
	printf("\n type VGA BIOS memory address to read, for ex. ");
	printf("\n USB2ISA(0x000c0000), SSI2 ISA(0xff0c0000) - ");
	scanf("%x", &mem);
	mem1 = mem & 0x00ffffff;
	if (!mem1 || (mem1 < 0x0b0000) || (mem1 > 0x0f0000) )
	{
		printf("\n ??? error selecting memory area ");
		goto l1;
	}


//	cdcl=FALSE;		// ???????????????

	// single rd cmd
	printf("\n single read : ISA VGA memory or BIOS content from address - %x ", mem);
	for (i=0; i<0x100; i++)
	{
		if ( !(i & 0x0f) )
			printf("\n");
		if ( cdcl)
			buf[i] = rd8(mem+i);	// __cdecl
		else
			buf[i] = vrd8(mem+i);	// __stdcall
	}



	// display
	for (i=0; i<0x100; i++)
	{
		if ( !(i & 0x0f) )
			printf("\n");
		printf("%02x / %c, ",buf[i],buf[i]);
	}


// !!! exrcise of physical memory api set - list all available commands
// shown arbitrary values written/read , to arbitrary memory location - no real data; 
// the hardware has to allow 8 or 16 or 32bit / read or write , to have real data


	if ( cdcl)
	{
		wr8(mem+4, 0x12);		// __cdecl
		i = rd8(mem+4);
		wr16(mem+4, 0x1234);
		i = rd16(mem+4);
	}
	else
	{
		vwr8(mem+4, 0x12);		// __stdcall
		i = vrd8(mem+4);
		vwr16(mem+4, 0x1234);
		i = vrd16(mem+4);
	}


	goto l1;







ex: ;

	if ( cdcl)
		ArsExit();
	else
		vArsExit();

	UnloadARSUSBdll2();


	return 1;
}




